Bug 1176035 (CVE-2014-9294) - CVE-2014-9294 ntp: ntp-keygen uses weak random number generator and seed when generating MD5 keys
Summary: CVE-2014-9294 ntp: ntp-keygen uses weak random number generator and seed when...
Status: CLOSED ERRATA
Alias: CVE-2014-9294
Product: Security Response
Classification: Other
Component: vulnerability   
(Show other bugs)
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=moderate,public=20141219,repor...
Keywords: Security
Depends On: 1176067 1176068 1176069 1176070 1176100 1176191 1176680 1182167
Blocks: 1176041
TreeView+ depends on / blocked
 
Reported: 2014-12-19 08:56 UTC by Huzaifa S. Sidhpurwala
Modified: 2019-03-22 07:29 UTC (History)
12 users (show)

Fixed In Version: ntp 4.2.8
Doc Type: Bug Fix
Doc Text:
It was found that ntp-keygen used a weak method for generating MD5 keys. This could possibly allow an attacker to guess generated MD5 keys that could then be used to spoof an NTP client or server. Note: it is recommended to regenerate any MD5 keys that had explicitly been generated with ntp-keygen; the default installation does not contain such keys.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-12-20 02:46:51 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:2024 normal SHIPPED_LIVE Important: ntp security update 2014-12-20 07:40:29 UTC
Red Hat Product Errata RHSA-2014:2025 normal SHIPPED_LIVE Important: ntp security update 2014-12-20 05:43:37 UTC
Red Hat Product Errata RHSA-2015:0104 normal SHIPPED_LIVE Important: ntp security update 2015-01-28 23:52:05 UTC

Description Huzaifa S. Sidhpurwala 2014-12-19 08:56:05 UTC
As per upstream NTP security advisory:

Prior to ntp-4.2.7p230 ntp-keygen used a weak seed to prepare a random number generator that was of good quality back in the late 1990s. The random numbers produced was then used to generate symmetric keys. In ntp-4.2.8 we use a current-technology cryptographic random number generator, either RAND_bytes from OpenSSL, or arc4random(). 

Mitigation: Upgrade to 4.2.7p230 or later.

This vulnerability was discovered in ntp-4.2.6 by Stephen Roettger of the Google Security Team.

Comment 1 Tomas Hoger 2014-12-19 10:07:03 UTC
Upstream change to the NEWS file with details quoted in comment 0:

http://bk1.ntp.org/ntp-dev/?PAGE=patch&REV=5493dc3dofY6drKJde9W-5O1M3s4eg

This seems to be the seeding fix applied between 4.2.7p229 and 4.2.7p230:

http://bk1.ntp.org/ntp-dev/util/ntp-keygen.c?PAGE=diffs&REV=4eae1b72298KRoBQmX-y8URCiRPH5g

Upstream bug:
http://bugs.ntp.org/show_bug.cgi?id=2666

There is another recent change in 4.2.8 which makes ntp use OpenSSL or arc4random for key generation:
http://bk1.ntp.org/ntp-dev/?PAGE=patch&REV=548db6ddlELn4rnqUZ4kKGOjvtXwbQ

Comment 8 Tomas Hoger 2014-12-19 16:21:45 UTC
Created ntp tracking bugs for this issue:

Affects: fedora-all [bug 1176191]

Comment 9 errata-xmlrpc 2014-12-20 00:44:23 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 5

Via RHSA-2014:2025 https://rhn.redhat.com/errata/RHSA-2014-2025.html

Comment 10 errata-xmlrpc 2014-12-20 02:40:38 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6
  Red Hat Enterprise Linux 7

Via RHSA-2014:2024 https://rhn.redhat.com/errata/RHSA-2014-2024.html

Comment 11 Fedora Update System 2014-12-22 02:37:31 UTC
ntp-4.2.6p5-19.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 Fedora Update System 2014-12-23 18:28:37 UTC
ntp-4.2.6p5-25.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2014-12-31 19:00:30 UTC
ntp-4.2.6p5-13.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 17 errata-xmlrpc 2015-01-28 18:52:32 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6.5 EUS - Server and Compute Node Only

Via RHSA-2015:0104 https://rhn.redhat.com/errata/RHSA-2015-0104.html


Note You need to log in before you can comment on or make changes to this bug.